unit hiHardDisk;

interface

uses
  Windows, Kol, Share, Debug;


type
  THIHardDisk = class(TDebug)
   private
   public
    _data_Disk:THI_Event;
    _prop_Disk:string;
    _prop_Size:integer;
    _prop_TypeData:integer;
    _prop_TypeDrive:integer;
    _prop_ErrorData:integer;
    _prop_TextEmptyLabel:string;
    _prop_TextEmptyFileSystem:string;
    _event_onEnum:THI_Event;
    _event_onEject:THI_Event;
    _event_onError:THI_Event;

    function WrongLetter(d:String):boolean;
	procedure _work_doLabel(var _Data:TData; Index:word);
    procedure _work_doEject(var _Data:TData; Index:word);
    procedure _work_doEnum(var _Data:TData; Index:word);
    procedure _work_doTextEmptyLabel(var _Data:TData; Index:word);
    procedure _work_doTextEmptyFileSystem(var _Data:TData; Index:word);
    procedure _var_Size(var _Data:TData; Index:word);
    procedure _var_FreeSize(var _Data:TData; Index:word);
    procedure _var_LoadSize(var _Data:TData; Index:word);
    procedure _var_DriveType(var _Data:TData; Index:word);
  end;

implementation

const
  _sx:array[0..2] of cardinal = (1,1024,1024*1024);
  _td:array[0..6] of string = ('UNKNOWN','NO_ROOT_DIR','REMOVABLE','FIXED','REMOTE','CDROM','RAMDISK');

  IOCTL_STORAGE_BASE   =     $0000002d;
  FILE_READ_ACCESS     =     $0001;
  FILE_ANY_ACCESS      =     $0000;
  FILE_DEVICE_FILE_SYSTEM =  $00000009;
  METHOD_BUFFERED         =  $0;
  IOCTL_STORAGE_MEDIA_REMOVAL = ((IOCTL_STORAGE_BASE shl 16) or
                                     (FILE_READ_ACCESS shl 14) or
                                     ($0201 shl 2) or METHOD_BUFFERED);
  IOCTL_STORAGE_EJECT_MEDIA   = ((IOCTL_STORAGE_BASE shl 16) or
                                     (FILE_READ_ACCESS shl 14) or
                                     ($0202 shl 2) or METHOD_BUFFERED);

  FSCTL_LOCK_VOLUME = ((FILE_DEVICE_FILE_SYSTEM shl 16) or
                            (FILE_ANY_ACCESS shl 14) or
                            (6 shl 2) or METHOD_BUFFERED);
  FSCTL_DISMOUNT_VOLUME = ((FILE_DEVICE_FILE_SYSTEM shl 16) or
                                (FILE_ANY_ACCESS shl 14) or
                                (8 shl 2) or METHOD_BUFFERED);

function THIHardDisk.WrongLetter(d:String):boolean;
begin
  if (Length(d) = 0) or not (d[1] in ['A'..'Z','a'..'z']) then
    begin
      Result := true;
      if _prop_ErrorData = 0 then //123 - ERROR_INVALID_NAME
	    _hi_onEvent(_event_onError,123)
	  else
	    _hi_onEvent(_event_onError,SysErrorMessage(123));
    end
  else 
   Result := false;
end;

procedure THIHardDisk._work_doLabel;
begin
     SetVolumeLabel(PChar(ReadString(_Data,_data_Disk,_prop_Disk) + '\'), PChar(Share.ToString(_Data)));
end;

procedure THIHardDisk._work_doEnum(var _Data:TData; Index:word);
var
  Drive: byte;
  dt,ndt,odt:TData;
  s:PData;
  d:string;
  serial,mcl:DWORD;
  vol,fs:array[0..255] of char;
begin
  for Drive := 0 to 25 do
    if GetLogicalDrives and (1 shl Drive) > 0 then
     begin
       d := Chr(Drive + $41) + ':\'; 
       dtString(dt, Chr(Drive + $41));       
       if _prop_TypeDrive = 0 then
	    dtInteger(ndt,GetDriveType(PChar(d)))
	   else
	    dtString(ndt,_td[GetDriveType(PChar(d))]); 	 
       AddMTData(@dt,@ndt,s);
       mcl := 0;
	   serial := 0;
	   StrLCopy(PChar(@vol[0]), PChar(_prop_TextEmptyLabel), High(vol));
	   StrLCopy(PChar(@fs[0]), PChar(_prop_TextEmptyFileSystem), High(fs));
	   GetVolumeInformation(PChar(d), vol, 256, @serial, mcl, mcl, fs, 256);
       dtString(ndt, string(vol));
       AddMTData(@dt,@ndt,s);
       dtInteger(ndt, serial);
       AddMTData(@dt,@ndt,s);
       dtString(ndt, string(fs));
       AddMTData(@dt,@ndt,s);
	   odt := dt;
       _hi_onEvent(_event_onEnum, dt);
       FreeData(@odt);
     end;
end; 

procedure THIHardDisk._work_doEject;
var hVolume:cardinal;
    PMRBuffer:boolean;
    dwBytesReturned:DWORD;
    d:string;
begin
 d := ReadString(_Data,_data_Disk,_prop_Disk);
 if WrongLetter(d) then exit;
 hVolume := CreateFile(PChar('\\.\' + d[1] + ':'), GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
 PMRBuffer := False;
 if( hVolume <> INVALID_HANDLE_VALUE )then
  begin
   if(  (DeviceIoControl(hVolume, FSCTL_LOCK_VOLUME, nil, 0, nil, 0, dwBytesReturned, nil))
    and (DeviceIoControl(hVolume, FSCTL_DISMOUNT_VOLUME, nil, 0, nil, 0,  dwBytesReturned, nil))
	and (DeviceIoControl(hVolume, IOCTL_STORAGE_MEDIA_REMOVAL,@PMRBuffer, sizeof(PMRBuffer), nil, 0, dwBytesReturned, nil))
	and (DeviceIoControl(hVolume, IOCTL_STORAGE_EJECT_MEDIA, nil, 0, nil, 0, dwBytesReturned, nil)) )then
      _hi_onEvent(_event_onEject)
   else
     if _prop_ErrorData = 0 then
	   _hi_onEvent(_event_onError,Integer(GetLastError))
	 else
	   _hi_onEvent(_event_onError,SysErrorMessage(GetLastError));
  end
   else
     if _prop_ErrorData = 0 then
	   _hi_onEvent(_event_onError,Integer(GetLastError))
	 else
	   _hi_onEvent(_event_onError,SysErrorMessage(GetLastError));  
  CloseHandle(hVolume);
end;

procedure THIHardDisk._work_doTextEmptyLabel(var _Data:TData; Index:word);
begin
   _prop_TextEmptyLabel := Share.ToString(_Data);
end;

procedure THIHardDisk._work_doTextEmptyFileSystem(var _Data:TData; Index:word);
begin
   _prop_TextEmptyFileSystem := Share.ToString(_Data);
end;

procedure THIHardDisk._var_Size;
var X,Y,Z,S:DWord;
    d:string;
begin
  d := ReadString(_Data,_data_Disk,_prop_Disk);
  if WrongLetter(d) then exit;
  d := d[1] + ':';
  getDiskFreeSpace(PChar(d),X,Y,Z,S);
  if _prop_TypeData = 0 then
    dtInteger(_Data,(S div 1024)*X*Y div _sx[_prop_Size])
  else
    dtReal(_Data,round((S / 1024)*X*Y / _sx[_prop_Size] * 10) / 10);
end;

procedure THIHardDisk._var_FreeSize;
var X,Y,Z,S:DWord;
    d:string;
begin
  d := ReadString(_Data,_data_Disk,_prop_Disk);
  if WrongLetter(d) then exit;
  d := d[1] + ':';
  getDiskFreeSpace(PChar(d),X,Y,Z,S);
  if _prop_TypeData = 0 then
    dtInteger(_Data,(Z div 1024)*X*Y div _sx[_prop_Size])
  else
    dtReal(_Data,round((Z / 1024)*X*Y / _sx[_prop_Size] * 10) / 10); 
end;

procedure THIHardDisk._var_LoadSize;
var X,Y,Z,S:DWord;
    d:string;
begin
  d := ReadString(_Data,_data_Disk,_prop_Disk);
  if WrongLetter(d) then exit;
  d := d[1] + ':';
  getDiskFreeSpace(PChar(d),X,Y,Z,S);
  if _prop_TypeData = 0 then
    dtInteger(_Data,((S-Z) div 1024)*X*Y div _sx[_prop_Size])
  else
    dtReal(_Data,round(((S-Z) / 1024)*X*Y / _sx[_prop_Size] * 10) / 10);  
end;

procedure THIHardDisk._var_DriveType;
var d:string;
begin
  d := ReadString(_Data,_data_Disk,_prop_Disk);
  if WrongLetter(d) then exit;
  d := d[1] + ':';
  if _prop_TypeDrive = 0 then
    dtInteger(_Data,GetDriveType(PChar(d)))
  else
    dtString(_Data,_td[GetDriveType(PChar(d))]); 
end;

end.
